const { ccclass, property } = cc._decorator;

@ccclass
export default class Move extends cc.Component {

    @property(cc.Vec2)
    private startPosition: cc.Vec2 = cc.v2(0, 0);

    @property(cc.Vec2)
    private endPosition: cc.Vec2 = cc.v2(0, 0);

    @property()
    private duration: number = 1;

    protected onLoad() {
        this.node.position = this.startPosition;
        this.node.runAction(cc.repeatForever(cc.sequence(
            cc.moveTo(this.duration, this.endPosition),
            cc.moveTo(this.duration, this.startPosition),
        )));
    }

}
