const { ccclass, property } = cc._decorator;

@ccclass
export default class Player extends cc.Component {

    @property(cc.Camera)
    private camera: cc.Camera = null;

    @property(cc.Prefab)
    private blockPrefab: cc.Prefab = null;

    @property(cc.Node)
    private blocks: cc.Node = null;

    protected update(dt) {
        this.camera.node.y += 500 * dt;
        this._generateBlock();
    }

    private _generateBlock() {
        const last = this.blocks.children[this.blocks.childrenCount - 1];
        if (this.camera.node.y + cc.winSize.height > last.y) {
            const block = cc.instantiate(this.blockPrefab);
            block.position = cc.v2(0, last.y + last.height);
            block.parent = this.blocks;
        }
        this.blocks.children.forEach((c) => {
            if (c.y + c.height < this.camera.node.y - cc.winSize.height / 2) {
                c.destroy();
            }
        });
    }
}
